var gulp = require('gulp');
var jshint = require('gulp-jshint');
var uglify = require('gulp-uglify');
var concat = require('gulp-concat');
var sourcemaps = require('gulp-sourcemaps');
var del = require('del');

var SRC_JS = 'src/**/*.js';
var DEST_JS = 'dist';
var DEST_FILE = 'jelastic.jquery.min.js'

function clean() {
    return del([DEST_JS]);
}

function lint() {
    return gulp.src(SRC_JS)
        .pipe(jshint())
        .pipe(jshint.reporter('default'))
        .pipe(jshint.reporter('fail'));
}

function scripts() {
    return gulp.src(SRC_JS)
        .pipe(sourcemaps.init())
        .pipe(uglify())
        .pipe(concat(DEST_FILE))
        .pipe(sourcemaps.write('.', { includeContent: false, sourceRoot: '../src' }))
        .pipe(gulp.dest(DEST_JS));
}

function watch() {
    gulp.watch(SRC_JS, scripts);
}

var build = gulp.series(clean, lint, scripts);

exports.clean = clean;
exports.scripts = scripts;
exports.watch = watch;
exports.build = build;
exports.default = build;
