(function ($) {
    $.jelastic = $.jelastic || {};
    $.jelastic.api = $.jelastic.api || {};

    $.jelastic.api.AbstractService = function (options) {
        var self,
            serviceUrl;

        options = options || {};
        options.baseUrl = options.baseUrl || $.jelastic.api.BASE_URL || "";
        options.session = options.session || $.jelastic.api.SESSION || "";

        self = {
            servicePath : "",

            request: function (method, params) {
                params = params || {};
                params.session = options.session;

                Object.keys(params).forEach(function (name) {
                    if (params[name] === null || typeof params[name] === 'undefined') {
                        delete params[name];
                    } else if ($.type(params[name]) === 'object' || $.type(params[name]) === 'array') {
                        params[name] = JSON.stringify(params[name]);
                    }
                });

                if (!serviceUrl) {
                    serviceUrl = options.baseUrl + self.servicePath;
                }

                return $.ajax({
                    url: serviceUrl + method,
                    data: params
                });
            }
        };

        return self;
    };
})(jQuery);